<template>
    <div class="">
            <page-header :title="edit ? 'Modification' : 'Nouvelle Location'">          
                     <div slot="nav">
                        <ol class="breadcrumb float-sm-right">
                            <li class="breadcrumb-item">
                                <router-link to="/locations" class="">Locations</router-link >
                                </li>
                            <li class="breadcrumb-item active"> {{ edit ? 'Modification' : 'Nouvelle Location'}}</li>
                        </ol>
                    </div>
            </page-header>
            <div class="col-md-12">
              <form class="mb-5" method="POST"  @keydown="form.errors.clear($event.target.name)" change="form.errors.clear($event.target.name)">
                    <div :class="['card bg-transparent']" >
                            <!-- /.card-header --> 
                    <div class="card-body  p-4 " >
                                <div class="form-group">
                                    <div class="row">
                                          <div class="col-md-6">
                                                      <div class="row">
                                          <div class="col-auto">
                                            <div class="form-check mt-1 ">
                                                <input class="form-check-input " type="checkbox" id="inlineCheckbox3" v-model="form.avec_chauffeur" name="avec_chauffeur" :checked="form.avec_chauffeur">
                                                    <label class="form-check-label" for="inlineCheckbox3">Avec Chauffeur ?</label>
                                                </div>
                                            <div class="form-check  mt-1 ">
                                                <input class="form-check-input " type="checkbox" id="inlineCheckbox2" v-model="form.longue_duree" name=".longue_duree" :checked="form.longue_duree">
                                                    <label class="form-check-label" for="inlineCheckbox2">Longue durée ?</label>
                                                </div>
                                        </div>
                                        <div class="col-auto">
                                            <div class="form-check  mt-1 ">
                                                <input class="form-check-input " type="checkbox" id="inlineCheckbox1" v-model="form.ancien_client"
                                                    name="ancien_client" :checked="form.ancien_client" @change="fixChange">
                                                    <label class="form-check-label" for="inlineCheckbox1">Nouveau client ?</label>
                                            </div>
                                            <div class="form-check mt-1 ">
                                                <input @click="clientChauffeurChanged" class="form-check-input " type="checkbox" id="inlineCheckbox4" v-model="form.client_est_chauffeur" name="client_est_chauffeur" :checked="form.client_est_chauffeur">
                                                    <label class="form-check-label" for="inlineCheckbox4">Le client est le chauffeur ?</label>
                                            </div>
                                        </div>
                                                      </div>
                                          </div>
                                          <div class="col-md-6">
                                            <div class="col-md-auto d-flex justify-content-start mt-2">
                                                <span data-v-44ea9974="" data-v-15965e3b="" class="badge badge-secondary text-uppercase">Durée de la location</span>
                                                <span data-v-44ea9974="" data-v-15965e3b="" class="ml-2 pt-1 text-uppercase">{{ duree > 1 ? duree+" jours" : duree+" jour"}}</span>

                                                <input class="form-control" type="text" disabled v-model="duree" style="display:none">
                                            </div>
                                          </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <div class="row">
                                        <div class="col-md-6">
                                            <label class="">Date de début de la location</label>
                                            <datetime placeholder="Date de début de la location " ref="date_dbt" v-model="date_dbt" :min-datetime="min_date" :max-datetime="max_date" @input="datepickerEvent($event,'date_dbt')"  class="theme-rouge"  type="datetime" :input-class="['form-control input','input']"   :phrases="{ cancel: 'Annuler',ok: 'Ok'}"></datetime>
                                            <!-- <VueCtkDateTimePicker format='YYYY-MM-DD hh:mm' @input="updateDate(e,'date_dbt')" 
                                            buttonColor="rgb(129, 135, 140)"
                                            buttonNowTranslation="Maintenant"
                                            input-size="sm"
                                            id="dbt" color="rgb(129, 135, 140)" locale="fr" label="Choisissez la date de début"  v-model="form.date_dbt" :no-error="form.errors.has('date_dbt')" :no-label="true" /> -->
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_dbt')" v-text="form.errors.get('date_dbt')"></span>

                                        </div>
                                        <div class="col-md-6">
                                            <label class="">Date de fin de la location</label>
                                            <datetime placeholder="Date de fin de la location " ref="date_fin_prev" v-model="date_fin_prev" :min-datetime="min_date_fin_prev"  @input="datepickerEvent($event,'date_fin_prev')"  class="theme-rouge"  type="datetime" :input-class="['form-control','input']"   :phrases="{ cancel: 'Annuler',ok: 'Ok'}"></datetime>

                                            <!-- <VueCtkDateTimePicker format='YYYY-MM-DD hh:mm' 
                                            input-size="sm"
                                            buttonColor="rgb(129, 135, 140)"
                                            buttonNowTranslation="Maintenant"
                                            @input="updateDate(e,'date_fin_prev')" id="fin" color="rgb(129, 135, 140)" locale="fr" label="Choisissez la date de retour" v-model="form.date_fin_prev" :no-error="form.errors.has('date_fin_prev')" :no-label="true"/> -->
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_fin_prev')" v-text="form.errors.get('date_fin_prev')"></span>
                                        </div>

                                    </div>
                                </div>
                                  <div class="form-group">
                                    <div class="row">
                                      <div class="col-md-6" >
                                          <template v-if="!form.ancien_client">
                                                <label class="">Client</label>
                                                <multi-select :disabled="form.ancien_client" :class="['',form.errors.has('client_id')?'is-invalid':'']" 
                                                    no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                                    v-model="selectedClient"  :options="options.clients" 
                                                    @input="onClientSelect"
                                                    :show-labels="false" :searchable="true" :clear-on-select="false" 
                                                    :close-on-select="true"  placeholder="Recherchez le client par son nom" label="nomComplet" track-by="id">
                                                </multi-select>
                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('client_id')" v-text="form.errors.get('client_id')"></span>
                                            </template >
                                            <template v-else>
                                                  <div class="row">
                                                        <div class="col">
                                                                    <label class="">Prénom du client</label>
                                                                    <input  :disabled="!form.ancien_client" :class="['form-control',form.errors.has('client.prenom')?'is-invalid':'']" name="client.prenom" v-model="form.client.prenom" type="text"/>
                                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.prenom')" v-text="form.errors.get('client.prenom')"></span>
                                                        </div>
                                                        <div class="col">
                                                                    <label class="">Nom du client</label>
                                                                    <input :disabled="!form.ancien_client"  :class="['form-control',form.errors.has('client.nom')?'is-invalid':'']"  name="client.nom" v-model="form.client.nom" type="text"/>
                                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.nom')" v-text="form.errors.get('client.nom')"></span>
                                                        </div>
                                                  </div>
                                            </template>
                                        </div>

                                        <div class="col-md-6">
                                            <label class="">Véhicule</label>
                                            <multi-select :class="['',form.errors.has('vehicule_id')?'is-invalid':'']" 
                                                no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                                v-model="selectedVehicule"  :options="options.vehicules" 
                                                @input="onVehiculeSelect"
                                                :show-labels="false" :searchable="true" :clear-on-select="false" 
                                                :close-on-select="true"  placeholder="Choisissez le véhicule" label="libelle" track-by="id">
                                            </multi-select>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('vehicule_id')" v-text="form.errors.get('vehicule_id')"></span>
                                        </div>

                                    </div>
                                </div>
                                  <div class="form-group">
                                    <div class="row">
                                      <div class="col-md-6">
                                            <div class="row">
                                                <div class="col">
                                                            <label class="">Adresse du client</label>
                                                            <input :disabled="!form.ancien_client"  :class="['form-control',form.errors.has('client.adresse')?'is-invalid':'']"  name="client.adresse" v-model="form.client.adresse" type="text"/>
                                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.adresse')" v-text="form.errors.get('client.adresse')"></span>
                                                </div>
                                                <div class="col ">
                                                    <label class="">Téléphone du client</label>
                                                            <input :disabled="!form.ancien_client"  :class="['form-control',form.errors.has('client.telephone1')?'is-invalid':'']"  name="client.telephone1" v-model="form.client.telephone1" type="text"/>
                                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.telephone1')" v-text="form.errors.get('client.telephone1')"></span>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="row" v-if="!form.avec_chauffeur">
                                                <div class="col">                                                         
                                                    <label class="">Nom du chauffeur</label>
                                                    <input  placeholder="Entrez le nom du chauffeur N° 1" :disabled="form.client_est_chauffeur" :class="['form-control',form.errors.has('nom_chauffeur')?'is-invalid':'']"  name="nom_chauffeur" v-model="form.nom_chauffeur" type="text"/>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom_chauffeur')" v-text="form.errors.get('nom_chauffeur')"></span>
                                                </div>
                                                <div class="col" v-show="!form.ancien_client">
                                                    <label class="">Nom du 2éme chauffeur</label>
                                                    <input placeholder="Entrez le nom du chauffeur N° 2" :disabled="form.nom_chauffeur==''"  :class="['form-control',form.errors.has('nom_chauffeur_2')?'is-invalid':'']" name="nom_chauffeur_2" v-model="form.nom_chauffeur_2" type="text"/>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom_chauffeur_2')" v-text="form.errors.get('nom_chauffeur_2')"></span>
                                                </div>
                                            </div>
                                            <div class="row" v-else>
                                              <div class="col">
                                                <label class="">Nom du chauffeur</label>
                                                <multi-select  :class="['',form.errors.has('chauffeur_id')?'is-invalid':'']" 
                                                    no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                                    v-model="selectedChauffeur"  :options="options.chauffeurs" 
                                                    @input="onChauffeurSelect"
                                                    :show-labels="false" :searchable="true" :clear-on-select="false" 
                                                    :close-on-select="true"  placeholder="Recherchez le chauffeur" label="nomComplet" track-by="id">
                                                </multi-select>
                                                 <span class="m-form__help m--font-danger"  v-if="form.errors.has('chauffeur_id')" v-text="form.errors.get('chauffeur_id')"></span>

                                              </div>
                                            </div>

                                        </div>
                                    </div>
                                </div>
                                <div class="form-group" v-if="form.ancien_client">
                                    <div class="row">
                                      <div class="col-md-6">
                                            <div class="row">
                                                <div class="col">
                                                    <label class="">Type de piece</label>
                                                    <multi-select :class="['',form.errors.has('client.type_piece_identite')?'is-invalid':'']" 
                                                        no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                                        v-model="form.client.type_piece_identite"  :options="['CNI','Passeport','Récepissé CNI','Autres']" 
                                                        :show-labels="false" :searchable="false" :clear-on-select="false" 
                                                        :close-on-select="true"  placeholder="Choisissez le type de pièce">
                                                    </multi-select>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.type_piece_identite')" v-text="form.errors.get('client.type_piece_identite')"></span>
                                                </div>
                                                <div class="col ">
                                                    <label class="">Copie de la pièce d'identité</label>
                                                    <document-input @file-has-changed="onDocumentInputChanged" placeholder="Choissisez votre fichier"></document-input>
                                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.piece_identite')" v-text="form.errors.get('client.piece_identite')"></span>

                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="row">
                                                <div class="col">
                                                    <label class="">Nom du 2éme chauffeur</label>
                                                    <input :disabled="form.nom_chauffeur==''"  :class="['form-control',form.errors.has('nom_chauffeur_2')?'is-invalid':'']" name="nom_chauffeur_2" v-model="form.nom_chauffeur_2" type="text"/>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom_chauffeur_2')" v-text="form.errors.get('nom_chauffeur_2')"></span>
                                                </div>
                                            </div>

                                        </div>
                                    </div>
                                </div>
                                <div class="form-group mb-0">
                                    <div class="row">
                                            <div class="col-md-6">
                                             <div class="form-group row">
                                                    <div class="col">
                                                            <label for="">Niveau de Carburant</label>
                                                            <multi-select :class="['',form.errors.has('niveau_carburant')?'is-invalid':'']"  name="niveau_carburant"
                                                                no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                                                v-model="form.niveau_carburant"  :options="['1/4','1/2','3/4','plein']" 
                                                                :show-labels="false" :searchable="false" :clear-on-select="false" 
                                                                :close-on-select="true"  placeholder="Choisissez le niveau de carburant">
                                                            </multi-select>
                                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('niveau_carburant')" v-text="form.errors.get('niveau_carburant')"></span>
                                                        </div>
                                                                <div class="form-group col">
                                                                    <label class="">Zone de location</label>
                                                        <select :class="['form-control',form.errors.has('zone_location')?'is-invalid':'']"  name="zone_location" v-model="form.zone_location" >
                                                            <option value="">Choissisez la zone</option>
                                                            <option :value="zone" v-for="(zone,key) in ['Libreville','Owendo','Akanda','Port-Gentil','Lambaréné','Franceville','Autres']" :key="key" > {{ zone }}</option>
                                                        </select>
                                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('zone_location')" v-text="form.errors.get('zone_location')"></span>
                                                            </div>
                                                    </div>
                                                <div class="row">

                                                    <div class=" form-group col-md-12">
                                                        <label class="">Observations</label>
                                                        <textarea placeholder="Entrez des observations concernant cette location" class="form-control " :class="[!avance ? 'min-height-textarea' : 'max-height-textarea','form-control',form.errors.has('observation')?'is-invalid':'']"  name="observation" v-model="form.observation" type="text"></textarea>
                                                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('observation')" v-text="form.errors.get('observation')"></span>
                                                        </div>
                                                </div>
                                            </div>
                                            <div class="col-md-6">

                                                    <div class=" form-group row">
                                                                <div class="col">
                                                                    <label class="">Frais de livraison </label>
                                                                    <div class="input-group">
                                                                    <div class="input-group-prepend">
                                                                        <span class="input-group-text">
                                                                        <input type="checkbox" name="livraison_effective"  v-model="form.livraison_effective">
                                                                        </span>
                                                                    </div>
                                                                    <input  disabled class="form-control " :class="['form-control',form.errors.has('frais_livraison')?'is-invalid':'']"  name="frais_livraison" v-model="form.frais_livraison" type="text"/>
                                                                    </div>
                                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('frais_livraison')" v-text="form.errors.get('frais_livraison')"></span>
                                                                </div>
                                                                <div class="col">
                                                                    <label class="">Lavage</label>
                                                                    <input disabled  class="form-control " :class="['form-control',form.errors.has('lavage_carburant')?'is-invalid':'']"  name="lavage_carburant" v-model="form.lavage_carburant" type="text"/>
                                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('lavage_carburant')" v-text="form.errors.get('lavage_carburant')"></span>
                                                                </div>
                                                    </div>

                                                    <div class="row">
                                                        <div class="col">
                                                            <label class="">Prix Tarif</label>
                                                            <input  class="form-control " :class="['form-control',form.errors.has('tarif')?'is-invalid':'']"  name="tarif" v-model="form.tarif" type="text"/>
                                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('tarif')" v-text="form.errors.get('tarif')"></span>
                                                        </div>
                                                        <div class="col">
                                                            <label class="">Montant</label>
                                                            <input disabled class="form-control " :class="['form-control',form.errors.has('montant')?'is-invalid':'']"  name="montant" v-model="ttc" type="text"/>
                                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('montant')" v-text="form.errors.get('montant')"></span>
                                                        </div>
                                                    </div>
                                                    <div class="row mt-3">
                                                        <div class="col">
                                                            <label class="">Statut du payement</label>
                                                         <multi-select  :class="['',form.errors.has('statut_payement_id')?'is-invalid':'']" 
                                                         no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                                          v-model="selectedStatut"  :options="options.payements" 
                                                          @input="onStatutSelect"
                                                          :show-labels="false" :searchable="false" :clear-on-select="false" 
                                                          :close-on-select="true"  placeholder="Choisir le statut du payement" label="nature" track-by="id">
                                                      </multi-select>
                                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('statut_payement_id')" v-text="form.errors.get('statut_payement_id')"></span>

                                                        </div>
                                                        <div class="col" v-if="avance">
                                                            <label class="">Avance</label>
                                                            <input placeholder="Entrez le montant" class="form-control " :class="['form-control',form.errors.has('avance')?'is-invalid':'']"  name="avance" v-model="form.avance" type="text"/>

                                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('avance')" v-text="form.errors.get('avance')"></span>

                                                        </div>
                                                        <div class="col-md-12 col-lg-12" v-if="avance">
                                                            <label class="">Reste à payer</label>
                                                            <input disabled  class="form-control " :class="['form-control']"  v-model="reste"  type="text"/>
                                                        </div>
                                                    </div>
                                            </div>

                                    </div>
                                </div>
                            </div>
                            <div class="card-footer">
                                <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
                                    <button @click.prevent="onSubmit" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
                                    <button @click.prevent="reset" :class="['btn btn-secondary btn-small mr-2']" :disabled="isLoading">Annuler</button>
                                </div>
                            </div>
                    </div>
            </form>
            </div>
    </div>
</template>

<script>

   import Form from "./../../classes/Form"
   import DocumentInput from "./../../components/DocumentInput"

   import Master from "./../Master.vue";


    export default {
        mixins: [Master],
        data(){
            return{
                ftime:true,
                edit : false,
                hasData:false,
                per_page:15,
                url:"/api/locations",
                moreParams:{},

                date_fin_prev:"",
                min_date_fin_prev:"",
                date_dbt:"",
                min_date:moment().format(),
                max_date:"",
                
                
                options:{
                  clients:[],
                  vehicules:[],
                  chauffeurs:[],
                  payements:[]
                },
                entity: {},
                selectedClient:"",
                selectedVehicule:"",
                selectedChauffeur:"",
                selectedStatut:"",
                isLoading:false,
                form : new Form({
                  avec_chauffeur:false,
                  client_id:"",
                  id:'',
                  vehicule_id:"",
                  date_dbt:"",
                  date_fin_prev:"",
                  nom_chauffeur:"",
                  nom_chauffeur_2:"",
                  livraison_effective:false,
                  client_est_chauffeur: false,
                  frais_livraison:0,
                  lavage_carburant:10000,
                  niveau_carburant:"",
                  nbr_jour : 0,
                  observation:"",
                  avance:"",
                  reste_a_payer:"",
                  montant:"",
                  tarif:0,
                  chauffeur_id:"",
                  statut_payement_id:"",
                  longue_duree:false,
                  ancien_client:false,
                  zone_location:'',
                    client: {
                       nom:"",
                       prenom:"",
                       adresse:'',
                       telephone1:'',
                       type_piece_identite:'',
                       piece_identite:''
                    },
                    vehicule :{
                       marque:"",
                       tvehicule:"",
                       immatriculation:"",
                       tarif:""
                    }
                }),
            }
        },
        created()
        {
           this.min_date_fin_prev = moment(this.min_date).add(1,'d').format() 
           this.fetchOptions()
           this.edit =  this.$route.params.id == undefined ? false : true ;
           if(this.edit)
           {
               axios.get("/api/locations/"+this.$route.params.id).then((response) => 
                { 

                       this.entity = response.data
                       if(this.entity.running)
                       {
                         flash('La location est déjà  en cours . Elle ne peut plus être modifée','info')
                         this.$router.push('/locations')
                       }
                       window.event.$emit("isLoading",false)
                       window.event.$emit("edit-is-ready",[])

                       
                },
                (error) => {
                         console.log("Promise Rejected:")

                });
           }
        },
        mounted() {

               window.event.$on('edit-is-ready',(e)=>
               {
                    this.selectedClient = this.entity.client
                    this.onClientSelect(this.entity.client)
                    this.selectedVehicule = this.options.vehicules.find(ex => { return this.entity.vehicule_id = ex.id})
                    this.onVehiculeSelect(this.selectedVehicule)

                    this.form.date_dbt = this.entity.date_dbt
                    this.form.date_fin_prev = this.entity.date_fin_prev
                    this.form.id = this.entity.id

                    this.date_dbt = moment(this.form.date_dbt).format()
                    this.min_date = moment().format()


                    this.date_fin_prev = moment(this.form.date_fin_prev).format()
                    this.min_date_fin_prev = moment(this.form.date_dbt).add(1,'days').format()
                    this.max_date =moment(this.date_fin_prev).subtract(1,'days').format()
                    
                    this.form.avec_chauffeur = this.entity.avec_chauffeur
                    this.form.client_est_chauffeur = this.entity.client_est_chauffeur
                    this.form.longue_duree = this.entity.longue_duree
                    this.form.nom_chauffeur = this.entity.nom_chauffeur
                    this.form.nom_chauffeur_2 = this.entity.nom_chauffeur_2 ==null ? "" : this.entity.nom_chauffeur_2
                    this.form.chauffeur_id = this.entity.avec_chauffeur ? this.entity.chauffeur_id : ""

                    if(!isDefined(this.entity.chauffeur_id))
                    this.selectedChauffeur =  ""
                     else
                     this.selectedChauffeur =this.options.chauffeurs.find(ez => { return this.entity.chauffeur_id = ez.id})

                    if(!isDefined(this.entity.statut_payement_id))
                    {
                      this.selectedStatut =  ""
                      this.form.statut_payement_id=""
                    }
                     else
                     {
                       this.form.statut_payement_id=this.entity.statut_payement_id
                       
                       this.selectedStatut =this.options.payements.find(ez => { return this.entity.statut_payement_id = ez.id})
                       if(this.selectedStatut.nature=="avance")
                       {
                         this.form.avance = 0;
                       }

                     }

                   this.form.zone_location = this.entity.zone_location
                    this.form.livraison_effective = (this.entity.livraison_effective==0)
                    this.form.tarif = this.entity.tarif
                    this.form.niveau_carburant = this.entity.niveau_carburant
                     this.form.observation= this.entity.observation
                        if(this.init==true)
                        {
                          this.init =false
                        }
                        if(this.pageInit==false)
                        {
                            this.pageInit =true
                        }

               })
        },
        computed:
         {
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'une  location"  : " Ajout d'une location"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Valider"  : "Valider"
            },
              ancien_client()
            {

              return this.form.client.ancien_client==true ? true : false
            
            },
             duree()
            {
                 
              if(moment(this.form.date_dbt, moment.ISO_8601, true).isValid() &&  moment(this.form.date_fin_prev, moment.ISO_8601, true).isValid()) 
                {
                  
                  var start = moment(this.form.date_dbt,"YYYY-MM-DD"); //todays date
                  var end = moment(this.form.date_fin_prev,"YYYY-MM-DD"); // another date
                  var duration = moment.duration(end.diff(start));
                  
                  this.form.nbr_jour = duration.asDays();
                  return  this.form.nbr_jour
                }
              else
                return 0
            
            },
             tarif()
            {
                  return this.form.tarif
            },
             htc()
            {
               var montant = 0

               this.form.montant = this.duree * this.tarif + this.form.frais_livraison  + this.form.lavage_carburant
               montant = this.form.montant 

                    
               
               
               return montant
            },
              ttc()
            {
                  this.form.montant_ttc = this.htc 
                 return this.monnaie(this.htc)
            },
            avance()
            {
                  if(isDefined(this.selectedStatut))
                  {
                       if(this.selectedStatut.nature=="avance")
                       return true
                  }
                 return false
            },
            reste()
            {
                 if(this.avance && isDefined(this.selectedVehicule) && this.form.nbr_jour>=1 && isDefined(this.form.avance))
                 {
                   this.form.reste_a_payer = this.form.montant-this.form.avance
                   return monnaie(this.form.reste_a_payer);
                 }
                 return ""
            },
              nom_chauffeur_live: function(value) 
            {
               var fullname = ""
               if(this.form.client_est_chauffeur)
               {
                 if(isDefined(this.form.client.nom) && isDefined(this.form.client.prenom))
                 {
                    fullname = this.form.client.nom+" "+this.form.client.prenom
                    this.form.nom_chauffeur = fullname
                 }
               }
               return fullname;
            },
         },
        methods: 
        {
          clientChauffeurChanged(e)
          { 
            if(e.target.result)
            {
               if(this.form.client.nom!="" && this.form.client.prenom!="")
               {
                  this.form.nom_chauffeur = this.form.client.prenom+" "+this.form.client.nom
                  if(this.form.errors.has('nom_chauffeur'))
                  {
                    this.form.errors.clear('nom_chauffeur')
                  }
               }
               this.form.avec_chauffeur = false;
             }
             else
             {
               this.form.nom_chauffeur = ""
                if(this.form.errors.has('nom_chauffeur'))
                {
                  this.form.errors.clear('nom_chauffeur')
                }
             }
          },
            //Ecoute les events du doc input file
            onDocumentInputChanged(name)
            {
               if(isDefined(name))
               {
                   this.form.client.piece_identite = name 
                   
               }
               if(this.form.errors.has('client.piece_identite'))
                  this.form.errors.clear('client.piece_identite')
            },
            //gere les datepickers
            datepickerEvent(event,name)
            {        if(isDefined(event))
                    {
                          if(name=='date_dbt')
                         {
                            var instant = moment(event)
                            this.form[name] = instant.format('YYYY-MM-DD hh:mm')
                            this.min_date_fin_prev = moment(this.form[name]).add(1,'days').format()

                            this.form.date_fin_prev =instant.add(1,'days').format('YYYY-MM-DD hh:mm')
                            this.date_fin_prev = instant.format()

                            if(this.form.errors.has('date_fin_prev'))
                            {
                              this.form.errors.clear('date_fin_prev')
                            }
                          
                         }
                         else if(name='date_fin_prev')
                         {
                            this.form[name] = moment(event).format('YYYY-MM-DD hh:mm')
                            this.max_date = moment(this.form[name]).subtract(1,'days').format()
                            
                         }
                    } 
                    else
                    {
                        
                        this.min_date = moment().format()
             
                    }  
                    this.form.checkError(name)
         

            },
            updateDate(e,val) 
            {
                  if(this.form.errors.has(val))
                    this.form.errors.clear(val)
                  
            },
            fixChange(e)
            {
              if(e.target.checked==false)
             {
                   this.form.client_id = ""           
             }
                            
            this.form.client.nom=""
            this.form.client.prenom=""
            this.form.client.adresse=""
            this.form.client.telephone1=""
            this.selectedClient = ""
            if(this.form.client_est_chauffeur)
            this.form.nom_chauffeur = ""

            if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
            {
                this.form.errors.clear('client_id')
                this.form.errors.clear('client.nom')
                this.form.errors.clear('client.prenom')
                this.form.errors.clear('client.adresse')
                this.form.errors.clear('client.telephone1')
            }

            },
            onClientSelect(e)
            {
               if(e!=null)
               {
                this.form.client_id = e.id
                this.form.client.nom= e.nom
                this.form.client.prenom= e.prenom
                this.form.client.adresse= e.adresse
                this.form.client.telephone1= e.telephone1
                if(this.form.client_est_chauffeur)
                {
                    this.form.nom_chauffeur = this.form.client.prenom+" "+this.form.client.nom
                }
               }
               else
               {
                 this.form.client_id = ""
                this.form.client.nom= ""
                this.form.client.prenom= ""
                this.form.client.adresse= ""
                this.form.client.telephone1=""
                if(this.form.client_est_chauffeur)
                {
                    this.form.nom_chauffeur =""
                }  
               }


              if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
              {
                  this.form.errors.clear('client_id')
                  this.form.errors.clear('client.nom')
                  this.form.errors.clear('client.prenom')
                  this.form.errors.clear('client.adresse')
                  this.form.errors.clear('client.telephone1')
              }
            },
            onStatutSelect(e)
            {
               if(e!=null)
               {
                  this.form.statut_payement_id = e.id
                  if(e.nature=="payé")
                  this.form.reste_a_payer = 0
               }
               else
               {
                 this.form.statut_payement_id_id = ""
  
               }


              if(this.form.errors.has('statut_payement_id') )
              {
                  this.form.errors.clear('statut_payement_id')
              }
            },
            onChauffeurSelect(e)
            {
               if(e!=null)
               {
                this.form.chauffeur_id = e.id
               }
               else
               {
                 this.form.chauffeur_id = ""
                if(this.form.client_est_chauffeur)
                {
                    this.form.nom_chauffeur =""
                }  
               }


              if(this.form.errors.has('chauffeur_id') )
              {
                  this.form.errors.clear('chauffeur_id')
              }
            },
              onVehiculeSelect(e)
            {
              if(isDefined(e))
              {
               this.form.vehicule_id = e.id
               this.form.vehicule.marque = e.marque.libelle
               this.form.vehicule.tvehicule = e.type_vehicule.libelle
               this.form.vehicule.immatriculation = e.plaque_immatriculation
               this.form.vehicule.tarif = e.tarif
               this.form.tarif = e.tarif
              }
              else
              {
                this.form.vehicule_id = ""
               this.form.vehicule.marque = ""
               this.form.vehicule.tvehicule = ""
               this.form.vehicule.immatriculation = ""
               this.form.vehicule.tarif = ""
               this.form.tarif = ""   
              }


              if(this.form.errors.has('vehicule_id') )
              {
                  this.form.errors.clear('vehicule_id')
              }
            },
            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            monnaie: function(value) 
            {
               return  numeral(value).format('0,0');
            },

            onLoading() 
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                }
                this.ftime = false
            },
            onLoadingDone() 
            {
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },
              //Initialisation du formulaire
              reset()
             {
                  this.modeEdit = false
                  this.isLoading = false
                  this.form.client.nom =""
                  this.form.client.adresse =""
                  this.form.client.telephone1 =""
                  this.form.client.ancien_client =false
                  this.form.vehicule.marque =""
                  this.form.vehicule.tvehicule =""
                  this.form.vehicule.immatriculation =""
                  this.form.vehicule.tarif =""
                  this.form.avec_chauffeur = false
                  this.form.client_est_chauffeur = false
                  this.form.longue_duree = false

                  this.selectedClient = ""
                  this.selectedVehicule = ""
                  this.form.date_dbt = ""
                  this.form.date_fin_prev = ""
                  this.form.nom_chauffeur = ""
                  this.form.nom_chauffeur_2 = ""
                  this.form.zone_location = ""
                  this.form.livraison_effective = false
                  this.form.tarif = 0
                  this.fonrm.errors.clearAll()
                  this.$refs['inputModal'].hide()

                  if(this.moreParams.hasOwnProperty('filter'))
                  this.moreParams.filter=""
             },
              fetchOptions()
             {
               axios.get("/api/dispatcher/options/locations").then((response) => 
                { 
                    
                      this.options.clients = response.data.clients
                      this.options.vehicules = response.data.vehicules
                      this.options.chauffeurs = response.data.chauffeurs
                      this.options.payements = response.data.payements

                      
                      //envoie un event pour signifier le chargement des options
                      this.$emit('initOption');
                      this.pageInit =true
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },
                          //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Requête ajax
                var url = this.edit ? this.url+"/"+this.entity.id : this.url
                this.form[ this.edit ? 'patch' : 'post'](url,{params:{id:this.edit ? this.entity.id   : ''}}).then((response) => 
                { 
                  if(response.success)
                  {
                        // on ramène les données sur la page 1
                        flash("<span>Mise en location <strong>"+(this.edit ? "modifiée" : "enregistrée")+"</strong></span>")
                        this.$router.push(this.edit ? "/locations/"+this.entity.id : "/locations" ,{});
                  }
                  else
                  {
                        flash("<span>Traitement<strong> impossible</strong></span>","error")
                        
                  }
                  this.isLoading = false
                 



                },
                (error) =>
                {
                  this.isLoading = false
                });                  
            }
       },
        components:
        {
             DocumentInput
        },
        watch:
        {
          "form.livraison_effective":function(value)
          {
            if(value==true)
             this.form.frais_livraison = 5000
             else
              this.form.frais_livraison = 0
          },
         "form.niveau_carburant":function(value)
          {
            if(this.form.errors.has('niveau_carburant'))
            {
              this.form.errors.clear('niveau_carburant')
            }
          },
          "form.client.type_piece_identite":function(value)
          {
            if(this.form.errors.has('client.type_piece_identite'))
            {
              this.form.errors.clear('client.type_piece_identite')
            }
          },
          "form.ancien_client":function(value)
          {
            if(this.form.errors.has('client.type_piece_identite'))
            {
              this.form.errors.clear('client.type_piece_identite')
            }
            if(this.form.errors.has('client.piece_identite'))
            {
              this.form.errors.clear('client.piece_identite')
            }
          },
        "form.client.piece_identite":function(value)
          {
            if(this.form.errors.has('client.piece_identite'))
            {
              this.form.errors.clear('client.piece_identite')
            }
          },
          "form.avec_chauffeur":function(value)
          {
            if(value)
            this.form.client_est_chauffeur = false;
            if(this.form.errors.has('nom_chauffeur'))
            {
              this.form.errors.clear('nom_chauffeur')
            }
            if(this.form.errors.has('chauffeur_id'))
            {
                  this.form.errors.clear('chauffeur_id')
            }
          },
          "form.client_est_chauffeur":function(value)
          {
                if(value)
                {
                  if(this.form.client.nom!="" && this.form.client.prenom!="")
                  {
                      this.form.nom_chauffeur = this.form.client.prenom+" "+this.form.client.nom
                      if(this.form.errors.has('nom_chauffeur'))
                      {
                        this.form.errors.clear('nom_chauffeur')
                      }
                  }
                  if(this.form.avec_chauffeur )
                  this.form.avec_chauffeur = false;

                  if(this.form.errors.has('chauffeur_id'))
                  {
                        this.form.errors.clear('chauffeur_id')
                  }
                }
          },
          form: {
            handler(val){
                console.log('ok')
               //form.client_est_chauffeur

                //form.client_est_chauffeur
                if(val.avec_chauffeur)
                {

                }
                this.$forceUpdate()
            },
            deep: true
          },
          client_est_chauffeur:function(value)
          {
            console.log(value)
            if(value==true)
             {
               if(this.form.client.nom!="" && this.form.client.prenom!="")
               {
                  this.form.nom_chauffeur = this.form.client.prenom+" "+this.form.client.nom
                  if(this.form.errors.has('nom_chauffeur'))
                  {
                    this.form.errors.clear('nom_chauffeur')
                  }
               }
               alert('ok')
               this.form.avec_chauffeur = false;
             }
             else
             {
               this.form.nom_chauffeur = ""
                if(this.form.errors.has('nom_chauffeur'))
                {
                  this.form.errors.clear('nom_chauffeur')
                }
             }
          }
        }
    }
</script>
<style lang="scss" scoped>
   input[type="text"], select,.input
  {
    height: 38px !important;
        min-height: 38px !important;
  }
  
  .form-group {
    
}

#my-modal .modal-body
{
  overflow-x: hidden !important;
}
.modal-dialog-scrollable .modal-body {
      overflow-y: auto;
        overflow-x: hidden !important;

      
}
.min-height-textarea
{
min-height:100px;
}
.max-height-textarea
{
min-height:167px;
}
</style>